ivatar/tools/urls.py
# -*- coding: utf-8 -*-
"""
ivatar/tools URL configuration
"""

from django.urls import path, re_path
from .views import CheckView, CheckDomainView

urlpatterns = [  # pylint: disable=invalid-name
    path("check/", CheckView.as_view(), name="tools_check"),
    path("check_domain/", CheckDomainView.as_view(), name="tools_check_domain"),
    re_path("check_domain$", CheckDomainView.as_view(), name="tools_check_domain"),
]

ivatar/urls.py
# -*- coding: utf-8 -*-
"""
ivatar URL configuration
"""
from django.contrib import admin
from django.urls import path, include, re_path
from django.conf.urls.static import static
from django.views.generic import TemplateView, RedirectView
from ivatar import settings
from .views import AvatarImageView, GravatarProxyView, StatsView

urlpatterns = [  # pylint: disable=invalid-name
    path("admin/", admin.site.urls),
    path("i18n/", include("django.conf.urls.i18n")),
    path("openid/", include("django_openid_auth.urls")),
    path("tools/", include("ivatar.tools.urls")),
    re_path(
        r"avatar/(?P<digest>\w{64})", AvatarImageView.as_view(), name="avatar_view"
    ),
    re_path(
        r"avatar/(?P<digest>\w{32})", AvatarImageView.as_view(), name="avatar_view"
    ),
    re_path(r"avatar/$", AvatarImageView.as_view(), name="avatar_view"),
    re_path(
        r"avatar/(?P<digest>\w*)",
        RedirectView.as_view(url="/static/img/deadbeef.png"),
        name="invalid_hash",
    ),
    re_path(
        r"gravatarproxy/(?P<digest>\w*)",
        GravatarProxyView.as_view(),
        name="gravatarproxy",
    ),
    path(
        "description/",
        TemplateView.as_view(template_name="description.html"),
        name="description",
    ),
    # The following two are TODO TODO TODO TODO TODO
    path(
        "run_your_own/",
        TemplateView.as_view(template_name="run_your_own.html"),
        name="run_your_own",
    ),
    path(
        "features/",
        TemplateView.as_view(template_name="features.html"),
        name="features",
    ),
    path(
        "security/",
        TemplateView.as_view(template_name="security.html"),
        name="security",
    ),
    path(
        "privacy/", TemplateView.as_view(template_name="privacy.html"), name="privacy"
    ),
    path(
        "contact/", TemplateView.as_view(template_name="contact.html"), name="contact"
    ),
    path("talk_to_us/", RedirectView.as_view(url="/contact"), name="talk_to_us"),
    path("stats/", StatsView.as_view(), name="stats"),
]

MAINTENANCE = False
try:
    if settings.MAINTENANCE:
        MAINTENANCE = True
except Exception:  # pylint: disable=bare-except
    pass

if MAINTENANCE:
    urlpatterns.append(
        path("", TemplateView.as_view(template_name="maintenance.html"), name="home")
    )
    urlpatterns.insert(3, path("accounts/", RedirectView.as_view(url="/")))
else:
    urlpatterns.append(
        path("", TemplateView.as_view(template_name="home.html"), name="home")
    )
    urlpatterns.insert(3, path("accounts/", include("ivatar.ivataraccount.urls")))

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

ivatar/tools/forms.py
# -*- coding: utf-8 -*-
"""
Classes for our ivatar.tools.forms
"""
from django import forms
from django.utils.translation import gettext_lazy as _
from django.core.exceptions import ValidationError
from django.forms.utils import ErrorList

from ivatar.settings import AVATAR_MAX_SIZE
from ivatar.settings import MIN_LENGTH_URL, MAX_LENGTH_URL
from ivatar.settings import MIN_LENGTH_EMAIL, MAX_LENGTH_EMAIL


class CheckDomainForm(forms.Form):
    """
    Form handling domain check
    """

    domain = forms.CharField(
        label=_("Domain"),
        required=True,
        error_messages={"required": _("Cannot check without a domain name.")},
    )


class CheckForm(forms.Form):
    """
    Form handling check
    """

    mail = forms.EmailField(
        label=_("E-Mail"),
        required=False,
        min_length=MIN_LENGTH_EMAIL,
        max_length=MAX_LENGTH_EMAIL,
        error_messages={"required": _("Cannot check without a domain name.")},
    )

    openid = forms.CharField(
        label=_("OpenID"),
        required=False,
        min_length=MIN_LENGTH_URL,
        max_length=MAX_LENGTH_URL,
        error_messages={"required": _("Cannot check without an openid name.")},
    )

    size = forms.IntegerField(
        label=_("Size"),
        initial=80,
        min_value=5,
        max_value=AVATAR_MAX_SIZE,
        required=True,
    )

    default_opt = forms.ChoiceField(
        label=_("Default"),
        required=False,
        widget=forms.RadioSelect,
        choices=[
            ("retro", _("Retro style (similar to GitHub)")),
            ("robohash", _("Roboter style")),
            ("pagan", _("Retro adventure character")),
            ("wavatar", _("Wavatar style")),
            ("monsterid", _("Monster style")),
            ("identicon", _("Identicon style")),
            ("mm", _("Mystery man")),
            ("mmng", _("Mystery man NextGen")),
            ("none", _("None")),
        ],
    )

    default_url = forms.URLField(
        label=_("Default URL"),
        min_length=1,
        max_length=MAX_LENGTH_URL,
        required=False,
    )

    def clean(self):
        self.cleaned_data = super().clean()
        mail = self.cleaned_data.get("mail")
        openid = self.cleaned_data.get("openid")
        default_url = self.cleaned_data.get("default_url")
        default_opt = self.cleaned_data.get("default_opt")
        if default_url and default_opt and default_opt != "none":
            if "default_url" not in self._errors:
                self._errors["default_url"] = ErrorList()
            if "default_opt" not in self._errors:
                self._errors["default_opt"] = ErrorList()

            errstring = _("Only default URL OR default keyword may be specified")
            self._errors["default_url"].append(errstring)
            self._errors["default_opt"].append(errstring)
        if not mail and not openid:
            raise ValidationError(_("Either OpenID or mail must be specified"))
        return self.cleaned_data

    def clean_openid(self):
        data = self.cleaned_data["openid"]
        return data.lower()

    def clean_mail(self):
        data = self.cleaned_data["mail"]
        return data.lower()

ivatar/tools/views.py
# -*- coding: utf-8 -*-
"""
View classes for ivatar/tools/
"""
from socket import inet_ntop, AF_INET6
import hashlib
import random

from django.views.generic.edit import FormView
from django.urls import reverse_lazy as reverse
from django.shortcuts import render

import DNS

from libravatar import libravatar_url, parse_user_identity
from libravatar import SECURE_BASE_URL as LIBRAVATAR_SECURE_BASE_URL
from libravatar import BASE_URL as LIBRAVATAR_BASE_URL

from ivatar.settings import SECURE_BASE_URL, BASE_URL
from .forms import (
    CheckDomainForm,
    CheckForm,
)  # pylint: disable=relative-beyond-top-level


class CheckDomainView(FormView):
    """
    View class for checking a domain
    """

    template_name = "check_domain.html"
    form_class = CheckDomainForm
    success_url = reverse("tools_check_domain")

    def form_valid(self, form):
        result = {}
        super().form_valid(form)
        domain = form.cleaned_data["domain"]
        result["avatar_server_http"] = lookup_avatar_server(domain, False)
        if result["avatar_server_http"]:
            result["avatar_server_http_ipv4"] = lookup_ip_address(
                result["avatar_server_http"], False
            )
            result["avatar_server_http_ipv6"] = lookup_ip_address(
                result["avatar_server_http"], True
            )
        result["avatar_server_https"] = lookup_avatar_server(domain, True)
        if result["avatar_server_https"]:
            result["avatar_server_https_ipv4"] = lookup_ip_address(
                result["avatar_server_https"], False
            )
            result["avatar_server_https_ipv6"] = lookup_ip_address(
                result["avatar_server_https"], True
            )
        return render(
            self.request,
            self.template_name,
            {
                "form": form,
                "result": result,
            },
        )


class CheckView(FormView):
    """
    View class for checking an e-mail or openid address
    """

    template_name = "check.html"
    form_class = CheckForm
    success_url = reverse("tools_check")

    def form_valid(self, form):
        mailurl = None
        openidurl = None
        mailurl_secure = None
        mailurl_secure_256 = None
        openidurl_secure = None
        mail_hash = None
        mail_hash256 = None
        openid_hash = None
        size = 80

        super().form_valid(form)

        if form.cleaned_data["default_url"]:
            default_url = form.cleaned_data["default_url"]
        elif (
            form.cleaned_data["default_opt"]
            and form.cleaned_data["default_opt"] != "none"
        ):
            default_url = form.cleaned_data["default_opt"]
        else:
            default_url = None

        if "size" in form.cleaned_data:
            size = form.cleaned_data["size"]
        if form.cleaned_data["mail"]:
            mailurl = libravatar_url(
                email=form.cleaned_data["mail"], size=size, default=default_url
            )
            mailurl = mailurl.replace(LIBRAVATAR_BASE_URL, BASE_URL)
            mailurl_secure = libravatar_url(
                email=form.cleaned_data["mail"],
                size=size,
                https=True,
                default=default_url,
            )
            mailurl_secure = mailurl_secure.replace(
                LIBRAVATAR_SECURE_BASE_URL, SECURE_BASE_URL
            )
            mail_hash = parse_user_identity(
                email=form.cleaned_data["mail"], openid=None
            )[0]
            hash_obj = hashlib.new("sha256")
            hash_obj.update(form.cleaned_data["mail"].encode("utf-8"))
            mail_hash256 = hash_obj.hexdigest()
            mailurl_secure_256 = mailurl_secure.replace(mail_hash, mail_hash256)
        if form.cleaned_data["openid"]:
            if not form.cleaned_data["openid"].startswith(
                "http://"
            ) and not form.cleaned_data["openid"].startswith("https://"):
                form.cleaned_data["openid"] = "http://%s" % form.cleaned_data["openid"]
            openidurl = libravatar_url(
                openid=form.cleaned_data["openid"], size=size, default=default_url
            )
            openidurl = openidurl.replace(LIBRAVATAR_BASE_URL, BASE_URL)
            openidurl_secure = libravatar_url(
                openid=form.cleaned_data["openid"],
                size=size,
                https=True,
                default=default_url,
            )
            openidurl_secure = openidurl_secure.replace(
                LIBRAVATAR_SECURE_BASE_URL, SECURE_BASE_URL
            )
            openid_hash = parse_user_identity(
                openid=form.cleaned_data["openid"], email=None
            )[0]

        return render(
            self.request,
            self.template_name,
            {
                "form": form,
                "mailurl": mailurl,
                "openidurl": openidurl,
                "mailurl_secure": mailurl_secure,
                "mailurl_secure_256": mailurl_secure_256,
                "openidurl_secure": openidurl_secure,
                "mail_hash": mail_hash,
                "mail_hash256": mail_hash256,
                "openid_hash": openid_hash,
                "size": size,
            },
        )


def lookup_avatar_server(domain, https):
    """
    Extract the avatar server from an SRV record in the DNS zone

    The SRV records should look like this:

       _avatars._tcp.example.com.     IN SRV 0 0 80  avatars.example.com
       _avatars-sec._tcp.example.com. IN SRV 0 0 443 avatars.example.com
    """

    if domain and len(domain) > 60:
        domain = domain[:60]

    service_name = None
    if https:
        service_name = "_avatars-sec._tcp.%s" % domain
    else:
        service_name = "_avatars._tcp.%s" % domain

    DNS.DiscoverNameServers()
    try:
        dns_request = DNS.Request(name=service_name, qtype="SRV").req()
    except DNS.DNSError as message:
        print("DNS Error: %s (%s)" % (message, domain))
        return None

    if dns_request.header["status"] == "NXDOMAIN":
        # Not an error, but no point in going any further
        return None

    if dns_request.header["status"] != "NOERROR":
        print("DNS Error: status=%s (%s)" % (dns_request.header["status"], domain))
        return None

    records = []
    for answer in dns_request.answers:
        if (
            ("data" not in answer)
            or (not answer["data"])
            or (not answer["typename"])
            or (answer["typename"] != "SRV")
        ):
            continue

        record = {
            "priority": int(answer["data"][0]),
            "weight": int(answer["data"][1]),
            "port": int(answer["data"][2]),
            "target": answer["data"][3],
        }

        records.append(record)

    target, port = srv_hostname(records)

    if target and ((https and port != 443) or (not https and port != 80)):
        return "%s:%s" % (target, port)

    return target


def srv_hostname(records):
    """
    Return the right (target, port) pair from a list of SRV records.
    """

    if len(records) < 1:
        return (None, None)

    if len(records) == 1:
        ret = records[0]
        return (ret["target"], ret["port"])

    # Keep only the servers in the top priority
    priority_records = []
    total_weight = 0
    top_priority = records[0]["priority"]  # highest priority = lowest number

    for ret in records:
        if ret["priority"] > top_priority:
            # ignore the record (ret has lower priority)
            continue

        # Take care - this if is only a if, if the above if
        # uses continue at the end. else it should be an elsif
        if ret["priority"] < top_priority:
            # reset the aretay (ret has higher priority)
            top_priority = ret["priority"]
            total_weight = 0
            priority_records = []

        total_weight += ret["weight"]

        if ret["weight"] > 0:
            priority_records.append((total_weight, ret))
        else:
            # zero-weigth elements must come first
            priority_records.insert(0, (0, ret))

    if len(priority_records) == 1:
        unused, ret = priority_records[0]  # pylint: disable=unused-variable
        return (ret["target"], ret["port"])

    # Select first record according to RFC2782 weight ordering algorithm (page 3)
    random_number = random.randint(0, total_weight)

    for record in priority_records:
        weighted_index, ret = record

        if weighted_index >= random_number:
            return (ret["target"], ret["port"])

    print("There is something wrong with our SRV weight ordering algorithm")
    return (None, None)


def lookup_ip_address(hostname, ipv6):
    """
    Try to get IPv4 or IPv6 addresses for the given hostname
    """

    DNS.DiscoverNameServers()
    try:
        if ipv6:
            dns_request = DNS.Request(name=hostname, qtype=DNS.Type.AAAA).req()
        else:
            dns_request = DNS.Request(name=hostname, qtype=DNS.Type.A).req()
    except DNS.DNSError as message:
        print("DNS Error: %s (%s)" % (message, hostname))
        return None

    if dns_request.header["status"] != "NOERROR":
        print("DNS Error: status=%s (%s)" % (dns_request.header["status"], hostname))
        return None

    for answer in dns_request.answers:
        if ("data" not in answer) or (not answer["data"]):
            continue
        if (ipv6 and answer["typename"] != "AAAA") or (
            not ipv6 and answer["typename"] != "A"
        ):
            continue  # skip CNAME records

        if ipv6:
            return inet_ntop(AF_INET6, answer["data"])

        return answer["data"]

    return None

ivatar/tools/templates/check.html
{% extends 'base.html' %}
{% load i18n %}
{% load static %}

{% block title %}{% trans 'Check e-mail or openid' %}{% endblock title %}

{% block content %}

{% if mailurl or openidurl %}
      <h2>This is what the avatars will look like depending on the hash and protocol you use:</h2>
    <p>
        {% if mail_hash %}
          MD5 hash (mail): {{ mail_hash }}<br/>
          SHA256 hash (mail): {{ mail_hash256 }}<br/>
        {% endif %}

        {% if openid_hash %}
          SHA256 hash (OpenID): {{ openid_hash }}<br/>
        {% endif %}
    </p>

    <div class="row">
      {% if mailurl %}
<div class="panel panel-tortin" style="min-width:132px;width:calc({{ size }}px + 33px);float:left;margin-left:20px">
  <div class="panel-heading">
    <h3 class="panel-title">MD5 <i class="fa fa-lock" title="Secure connection (https)"></i>&nbsp;<i class="fa fa-at" title="mail: {{ form.mail.value }}"></i></h3>
  </div>
  <div class="panel-body">
           <a href="{{ mailurl_secure }}">
              <center><img src="{{ mailurl_secure }}" style="max-width: {{ size }}px; max-height: {{ size }}px;"></center>
            </a>
</div>
</div>
<div class="panel panel-tortin" style="min-width:132px;width:calc({{ size }}px + 33px);float:left;margin-left:20px">
  <div class="panel-heading">
    <h3 class="panel-title">SHA256 <i class="fa fa-lock" title="Secure connection (https)"></i>&nbsp;<i class="fa fa-at" title="mail: {{ form.mail.value }}"></i></h3>
  </div>
  <div class="panel-body">
            <a href="{{ mailurl_secure_256 }}">
              <center><img src="{{ mailurl_secure_256 }}" style="max-width: {{ size }}px; max-height: {{ size }}px;"></center>
            </a>
</div>
</div>
      {% endif %}

      {% if openidurl %}
<div class="panel panel-tortin" style="min-width:132px;width:calc({{ size }}px + 33px);float:left;margin-left:20px">
  <div class="panel-heading">
    <h3 class="panel-title">SHA256 <i class="fa fa-lock" title="Secure connection (http)"></i>&nbsp;<i class="fa fa-openid" title="openid: {{ form.openid.value }}"></i></h3>
  </div>
  <div class="panel-body">
            <a href="{{ openidurl_secure }}">
              <center><img src="{{ openidurl_secure }}" style="max-width: {{ size }}px; max-height: {{ size }}px;"></center>
            </a>
</div>
</div>
      {% endif %}
    </div>
{% endif %}

<h1>{% trans 'Check e-mail or openid' %}</h1>

{% if form.errors %}
  {% for error in form.non_field_errors %}
    <div class="alert alert-danger" role="alert">{{ error|escape }}</div>
  {% endfor %}
{% endif %}

<div style="max-width:640px">
<form method="post" name="check">
{% csrf_token %}
<div class="form-group"><label for="id_mail">{% trans 'E-Mail' %}</label>
<input type="email" name="mail" maxlength="254" minlength="6" class="form-control" placeholder="{% trans 'E-Mail' %}" {% if form.mail.value %} value="{{ form.mail.value }}" {% endif %} id="id_mail"></div>
<div class="form-group"><label for="id_openid">{% trans 'OpenID' %}</label>
<input type="text" name="openid" maxlength="255" minlength="11" class="form-control" placeholder="{% trans 'OpenID' %}" {% if form.openid.value %} value="{{ form.openid.value }}" {% endif %} id="id_openid"></div>
<div class="form-group"><label for="id_size">{% trans 'Size' %}</label>
<input type="number" name="size" min="5" max="512" class="form-control" placeholder="{% trans 'Size' %}" {% if form.size.value %} value="{{ form.size.value }}" {% else %} value="100" {% endif %} required id="id_size"></div>
{% if form.default_url.errors %}
<div class="alert alert-danger" role="alert">{{ form.default_url.errors }}</div>
{% endif %}
<div class="form-group"><label for="id_default_url">{% trans 'Default URL or special keyword' %}</label>
<input type="text" name="default_url" class="form-control" placeholder="{% trans 'Default' %}" {% if form.default_url.value %} value="{{ form.default_url.value }}" {% endif %} id="id_default_url"></div>
{% if form.default_opt.errors %}
<div class="alert alert-danger" role="alert">{{ form.default_opt.errors }}</div>
{% endif %}

<div class="form-group"><label for="id_default_opt">{% trans 'Default (special keyword)' %}</label>
  {% for opt in form.default_opt.field.choices %}
  <div class="radio" {% if forloop.counter|divisibleby:2 %}even{% else %}odd{% endif %}>
    <input type="radio" name="default_opt" value="{{ opt.0 }}"
      id="default_opt-{{ opt.0 }}"
      {% if form.default_opt.value == opt.0 %}checked{% endif %}
    >
    <label for="default_opt-{{ opt.0 }}">{{ opt.1 }}</label>
  </div>
  {% endfor %}
</div>

  <div class="form-group">
      <button type="submit" class="button">{% trans 'Check' %}</button>
</div>
</form>
</div>

<div style="height:40px"></div>
{% endblock content %}

ivatar/tools/templates/check_domain.html
{% extends 'base.html' %}
{% load i18n %}
{% load static %}

{% block title %}{% trans 'Check domain' %}{% endblock title %}

{% block content %}

<div class="container">

  <h1>{% trans 'Check domain' %}</h1>

  {% if form.errors %}
    <p class="error">{% trans "Please correct errors below:" %}<br>
      {% if form.openid_identifier.errors %}
        {{ form.openid_identifier.errors|join:', ' }}
      {% endif %}
      {% if form.next.errors %}
        {{ form.next.errors|join:', ' }}
      {% endif %}
    </p>
  {% endif %}

  <div style="max-width:640px">
    <form method="post" name="lookup">
      {% csrf_token %}

      <div class="form-group"><label for="id_domain">{% trans 'Domain' %}</label>
        <input type="text" name="domain" maxlength="254" minlength="6" class="form-control" placeholder="{% trans 'Domain' %}" {% if form.domain.value %} value="{{ form.domain.value }}" {% endif %} id="id_domain">
      </div>
      <div class="form-group">
        <button type="submit" class="button">{% trans 'Check' %}</button>
      </div>
    </form>
  </div>

  {% if result %}
    <hr/>
    <h2>The following servers will be used for your domain</h2>
<div class="panel panel-tortin" style="width:intrinsic;margin-left:30px;float:left">
<div class="panel-heading">
<h3 class="panel-title"><i class="fa fa-unlock-alt"></i>&nbsp;HTTP Server</h3>
</div>
<div class="panel-body">
{% if result.avatar_server_http %}
<a href="http://{{result.avatar_server_http}}">
<h4 style="text-transform: none;">http://{{result.avatar_server_http}}</h4>
</a>
{% if result.avatar_server_http_ipv4 %}
<br><center>{{ result.avatar_server_http_ipv4 }}</center>
{% endif %}
{% if result.avatar_server_http_ipv6 %}
<br><center>{{ result.avatar_server_http_ipv6 }}</center>
{% endif %}
{% else %}
<a href="http://cdn.libravatar.org">
<h4 style="text-transform: none;">http://cdn.libravatar.org</h4>
</a>
{% endif %}
</div>
</div>
<div class="panel panel-tortin" style="width:intrinsic;margin-left:30px;float:left">
<div class="panel-heading">
<h3 class="panel-title"><i class="fa fa-lock"></i>&nbsp;HTTPS Server</h3>
</div>
<div class="panel-body">
{% if result.avatar_server_https %}
<a href="https://{{result.avatar_server_https}}">
<h4 style="text-transform: none;">https://{{result.avatar_server_https}}</h4>
</a>
{% if result.avatar_server_https_ipv4 %}
<br><center>{{ result.avatar_server_https_ipv4 }}</center>
{% endif %}
{% if result.avatar_server_https_ipv6 %}
<br><center>{{ result.avatar_server_https_ipv6 }}</center>
{% endif %}
{% else %}
<a href="https://seccdn.libravatar.org">
<h4 style="text-transform: none;">https://seccdn.libravatar.org</h4>
</a>
{% endif %}
</div>
</div>
  {% endif %}
</div>
<div style="height:40px"></div>
{% endblock content %}